#ifdef ATL_UCLEANN
#define ATL_sJIK84x0x84TN84x84x0_a1_b1 ATL_sgpNBmm_b1
#else
#define ATL_sJIK84x0x84TN84x84x0_a1_b1 ATL_spNBmm_b1
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK84x0x84TN84x84x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=84, NB=0, KB=84, 
 * lda=84, ldb=84, ldc=0, mu=4, nu=1, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *stM = A + 7056;
   const float *stN = B + (84*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(84*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 40
   const int incAm = 256, incAn = -7056;
   #define incBk 40
   const int incBm = -80, incBn = 84;
   #define incCm 4
   const int incCn = (ldc) - 84;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC1_0 = pC0[1];
         rC2_0 = pC0[2];
         rC3_0 = pC0[3];
         for (k=0; k < 2; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[84];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[168];
            rA3 = pA0[252];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[85];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[169];
            rA3 = pA0[253];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[86];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[170];
            rA3 = pA0[254];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[87];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[171];
            rA3 = pA0[255];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[88];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[172];
            rA3 = pA0[256];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[89];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[173];
            rA3 = pA0[257];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[90];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[174];
            rA3 = pA0[258];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[91];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[175];
            rA3 = pA0[259];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[92];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[176];
            rA3 = pA0[260];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[93];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[177];
            rA3 = pA0[261];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[94];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[178];
            rA3 = pA0[262];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[95];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[179];
            rA3 = pA0[263];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[96];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[180];
            rA3 = pA0[264];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[97];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[181];
            rA3 = pA0[265];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[98];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[182];
            rA3 = pA0[266];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[99];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[183];
            rA3 = pA0[267];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[100];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[184];
            rA3 = pA0[268];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[101];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[185];
            rA3 = pA0[269];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[102];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[186];
            rA3 = pA0[270];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[103];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[187];
            rA3 = pA0[271];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[104];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[188];
            rA3 = pA0[272];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[105];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[189];
            rA3 = pA0[273];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[106];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[190];
            rA3 = pA0[274];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[107];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[191];
            rA3 = pA0[275];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[108];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[192];
            rA3 = pA0[276];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[109];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[193];
            rA3 = pA0[277];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[110];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[194];
            rA3 = pA0[278];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[111];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[195];
            rA3 = pA0[279];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[28];
            rB0 = pB0[28];
            rA1 = pA0[112];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[196];
            rA3 = pA0[280];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[29];
            rB0 = pB0[29];
            rA1 = pA0[113];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[197];
            rA3 = pA0[281];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[30];
            rB0 = pB0[30];
            rA1 = pA0[114];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[198];
            rA3 = pA0[282];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[31];
            rB0 = pB0[31];
            rA1 = pA0[115];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[199];
            rA3 = pA0[283];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[32];
            rB0 = pB0[32];
            rA1 = pA0[116];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[200];
            rA3 = pA0[284];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[33];
            rB0 = pB0[33];
            rA1 = pA0[117];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[201];
            rA3 = pA0[285];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[34];
            rB0 = pB0[34];
            rA1 = pA0[118];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[202];
            rA3 = pA0[286];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[35];
            rB0 = pB0[35];
            rA1 = pA0[119];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[203];
            rA3 = pA0[287];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[36];
            rB0 = pB0[36];
            rA1 = pA0[120];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[204];
            rA3 = pA0[288];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[37];
            rB0 = pB0[37];
            rA1 = pA0[121];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[205];
            rA3 = pA0[289];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[38];
            rB0 = pB0[38];
            rA1 = pA0[122];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[206];
            rA3 = pA0[290];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rA0 = pA0[39];
            rB0 = pB0[39];
            rA1 = pA0[123];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[207];
            rA3 = pA0[291];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[84];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[168];
         rA3 = pA0[252];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[85];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[169];
         rA3 = pA0[253];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[86];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[170];
         rA3 = pA0[254];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[87];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[171];
         rA3 = pA0[255];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
