#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0TN1x1x16_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const int Kb = (K>>4)<<4;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + M;
   #define incAk 16
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 16
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < Kb; k += 16) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         switch(k = (K-Kb))
         {
         case 1:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            break;
         case 2:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            break;
         case 3:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            break;
         case 4:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            break;
         case 5:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            break;
         case 6:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            break;
         case 7:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            break;
         case 8:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            break;
         case 9:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            break;
         case 10:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            break;
         case 11:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            break;
         case 12:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            break;
         case 13:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            break;
         case 14:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += rA0 * rB0;
            break;
         case 15:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            break;
         case 0: ;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x0TN0x0x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   const int Kb = (K>>4)<<4;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + M;
   #define incAk 16
   const int incAm = ((((lda) << 2)) - Kb), incAn = -(Mb*lda);
   #define incBk 16
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 8
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
            for (k=0; k < Kb; k += 16) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[11];
               rA3 = pA3[11];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[13];
               rA3 = pA3[13];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[15];
               rA3 = pA3[15];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pB0 += incBk;
            }
            switch(k = (K-Kb))
            {
            case 1:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 2:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 3:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 4:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 5:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 6:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 7:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 8:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 9:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 10:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 11:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 12:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[11];
               rA3 = pA3[11];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 13:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[11];
               rA3 = pA3[11];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 14:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[11];
               rA3 = pA3[11];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[13];
               rA3 = pA3[13];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 15:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[11];
               rA3 = pA3[11];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[13];
               rA3 = pA3[13];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 0: ;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x0x0TN1x1x16_a1_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
