#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x56TN1x1x8_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=56, 
 * lda=56, ldb=56, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (56*(Mb));
   const float *stN = B + (56*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 0, incAn = -(56*(Mb));
   #define incBk 8
   const int incBm = -56, incBn = 56;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < 7; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x56TN56x56x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=56, 
 * lda=56, ldb=56, ldc=0, mu=12, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (56*(Mb));
   const float *stN = B + (56*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*12*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 616, incAn = -(56*(Mb));
   #define incBk 8
   const int incBm = -56, incBn = 56;
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
            for (k=0; k < 7; k++) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[56];
               rA2 = pA0[112];
               rA3 = pA0[168];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[224];
               rA5 = pA0[280];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[336];
               rA7 = pA0[392];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[448];
               rA9 = pA0[504];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[560];
               rA11 = pA0[616];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[57];
               rA2 = pA0[113];
               rA3 = pA0[169];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[225];
               rA5 = pA0[281];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[337];
               rA7 = pA0[393];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[449];
               rA9 = pA0[505];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[561];
               rA11 = pA0[617];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[58];
               rA2 = pA0[114];
               rA3 = pA0[170];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[226];
               rA5 = pA0[282];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[338];
               rA7 = pA0[394];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[450];
               rA9 = pA0[506];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[562];
               rA11 = pA0[618];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[59];
               rA2 = pA0[115];
               rA3 = pA0[171];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[227];
               rA5 = pA0[283];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[339];
               rA7 = pA0[395];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[451];
               rA9 = pA0[507];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[563];
               rA11 = pA0[619];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[60];
               rA2 = pA0[116];
               rA3 = pA0[172];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[228];
               rA5 = pA0[284];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[340];
               rA7 = pA0[396];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[452];
               rA9 = pA0[508];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[564];
               rA11 = pA0[620];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[61];
               rA2 = pA0[117];
               rA3 = pA0[173];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[229];
               rA5 = pA0[285];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[341];
               rA7 = pA0[397];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[453];
               rA9 = pA0[509];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[565];
               rA11 = pA0[621];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[62];
               rA2 = pA0[118];
               rA3 = pA0[174];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[230];
               rA5 = pA0[286];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[342];
               rA7 = pA0[398];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[454];
               rA9 = pA0[510];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[566];
               rA11 = pA0[622];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[63];
               rA2 = pA0[119];
               rA3 = pA0[175];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[231];
               rA5 = pA0[287];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[343];
               rA7 = pA0[399];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[455];
               rA9 = pA0[511];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[567];
               rA11 = pA0[623];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x56TN1x1x8_a1_bX(k, N, 56, alpha, ca + (56*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
